package com.microservices.pms.project.service;

import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.microservices.common.core.web.page.GenericsTableDataInfo;
import com.microservices.pms.project.domain.PmsProjectSprint;
import com.microservices.pms.project.domain.vo.*;

import java.util.List;

/**
 * 项目迭代Service接口
 * 
 * @author wanjia
 * @date 2023-10-11
 */
public interface IPmsProjectSprintService 
{
    /**
     * 查询项目迭代
     * 
     * @param id 项目迭代主键
     * @return 项目迭代
     */
    public PmsProjectSprintDetailVo selectPmsProjectSprint(Long id, PmsProjectSprintIssuesSearchVo pmsProjectSprintIssuesSearchVo);

    /**
     * 查询项目迭代列表
     * 
     * @param pmsProjectSprint 项目迭代
     * @return 项目迭代集合
     */
    public List<PmsProjectSprint> selectPmsProjectSprintList(PmsProjectSprint pmsProjectSprint);

    GenericsTableDataInfo<PmsProjectSprintDetailVo> selectPmsProjectSprintList(PmsProjectSprintSearchVo pmsProjectSprintSearchVo);

    public GenericsTableDataInfo<PmsProjectSprintDetailVo> selectAllPmsProjectSprintList(PmsProjectSprintSearchVo pmsProjectSprintSearchVo);

    /**
     * 新增项目迭代
     * 
     * @param pmsProjectSprint 项目迭代
     * @return 结果
     */
    public int insertPmsProjectSprint(PmsProjectSprint pmsProjectSprint);

    /**
     * 修改项目迭代
     * 
     * @param pmsProjectSprint 项目迭代
     * @return 结果
     */
    public int updatePmsProjectSprint(PmsProjectSprint pmsProjectSprint);

    /**
     * 批量删除项目迭代
     * 
     * @param ids 需要删除的项目迭代主键集合
     * @return 结果
     */
    public int deletePmsProjectSprintByIds(Long[] ids);

    JSONObject getPmsProjectSprintStatistics(String pmSprintIds);

    boolean completeSprint(PmsProjectSprintCompleteVo pmsProjectSprintCompleteVo);

    List<PmsProjectSprintSimpleVo> selectPmsProjectSimpleSprintByIds(Long[] testSheetLinkSprintIds);

    JSONArray getPmsProjectSprintBurnDownChart(Long pmSprintId);

    PmsProjectSprintSimpleVo findOrCreatePmsProjectSprint(PmsProjectSprint pmsProjectSprint);
}
